]> git.ipfire.org Git - thirdparty/dracut.git/blame - test/TEST-50-MULTINIC/test.sh
Makefile: s/dracut-initramfs-backup.sh/dracut-initramfs-restore.sh/
[thirdparty/dracut.git] / test / TEST-50-MULTINIC / test.sh
CommitLineData
a71f1b49
PS
1#!/bin/bash
2TEST_DESCRIPTION="root filesystem on NFS with multiple nics"
3
4KVERSION=${KVERSION-$(uname -r)}
5
6# Uncomment this to debug failures
fa7ada31 7#DEBUGFAIL="rd.shell"
51b28ba9
HH
8#SERIAL="udp:127.0.0.1:9999"
9SERIAL="null"
a71f1b49
PS
10
11run_server() {
12 # Start server first
13 echo "MULTINIC TEST SETUP: Starting DHCP/NFS server"
14
0be1785a 15 $testdir/run-qemu -hda $TESTDIR/server.ext2 -m 256M -nographic \
a71f1b49 16 -net nic,macaddr=52:54:00:12:34:56,model=e1000 \
0be1785a 17 -net socket,listen=127.0.0.1:12350 \
51b28ba9 18 -serial $SERIAL \
a71f1b49 19 -kernel /boot/vmlinuz-$KVERSION \
fa7ada31 20 -append "selinux=0 root=/dev/sda rd.debug rd.info rw quiet console=ttyS0,115200n81" \
0be1785a
HH
21 -initrd $TESTDIR/initramfs.server -pidfile $TESTDIR/server.pid -daemonize || return 1
22 sudo chmod 644 $TESTDIR/server.pid || return 1
a71f1b49
PS
23
24 # Cleanup the terminal if we have one
25 tty -s && stty sane
26
27 echo Sleeping 10 seconds to give the server a head start
28 sleep 10
29}
30
31client_test() {
32 local test_name="$1"
33 local mac1="$2"
34 local mac2="$3"
35 local mac3="$4"
36 local cmdline="$5"
37 local check="$6"
38
39 echo "CLIENT TEST START: $test_name"
40
41 # Need this so kvm-qemu will boot (needs non-/dev/zero local disk)
0be1785a 42 if ! dd if=/dev/zero of=$TESTDIR/client.img bs=1M count=1; then
a71f1b49
PS
43 echo "Unable to make client sda image" 1>&2
44 return 1
45 fi
46
0be1785a 47 $testdir/run-qemu -hda $TESTDIR/client.img -m 512M -nographic \
a71f1b49
PS
48 -net nic,macaddr=52:54:00:12:34:$mac1,model=e1000 \
49 -net nic,macaddr=52:54:00:12:34:$mac2,model=e1000 \
50 -net nic,macaddr=52:54:00:12:34:$mac3,model=e1000 \
0be1785a 51 -net socket,connect=127.0.0.1:12350 \
b2559a88 52 -hdc /dev/null \
a71f1b49 53 -kernel /boot/vmlinuz-$KVERSION \
fa7ada31 54 -append "$cmdline $DEBUGFAIL rd.retry=5 rd.debug rd.info ro quiet console=ttyS0,115200n81 selinux=0 rd.copystate" \
0be1785a 55 -initrd $TESTDIR/initramfs.testing
a71f1b49 56
0be1785a 57 if [[ $? -ne 0 ]] || ! grep -m 1 -q OK $TESTDIR/client.img; then
a71f1b49
PS
58 echo "CLIENT TEST END: $test_name [FAILED - BAD EXIT]"
59 return 1
60 fi
61
62
63 for i in $check ; do
64 echo $i
0be1785a 65 if ! grep -m 1 -q $i $TESTDIR/client.img; then
a71f1b49
PS
66 echo "CLIENT TEST END: $test_name [FAILED - BAD IF]"
67 return 1
68 fi
69 done
70
71 echo "CLIENT TEST END: $test_name [OK]"
72 return 0
73}
74
75
76test_run() {
77 if ! run_server; then
78 echo "Failed to start server" 1>&2
79 return 1
80 fi
6c980807
HH
81 test_client || { kill_server; return 1; }
82}
a71f1b49 83
6c980807 84test_client() {
a71f1b49
PS
85 # Mac Numbering Scheme
86 # ...:00-02 receive IP adresses all others don't
87 # ...:02 receives a dhcp root-path
88
89 # PXE Style BOOTIF=
90 client_test "MULTINIC root=nfs BOOTIF=" \
91 00 01 02 \
92 "root=nfs:192.168.50.1:/nfs/client BOOTIF=52-54-00-12-34-00" \
93 "eth0" || return 1
94
95 # PXE Style BOOTIF= with dhcp root-path
96 client_test "MULTINIC root=dhcp BOOTIF=" \
97 00 01 02 \
98 "root=dhcp BOOTIF=52-54-00-12-34-02" \
99 "eth2" || return 1
100
101 # Multinic case, where only one nic works
102 client_test "MULTINIC root=nfs ip=dhcp" \
103 FF 00 FE \
104 "root=nfs:192.168.50.1:/nfs/client ip=dhcp" \
105 "eth1" || return 1
106
107 # Require two interfaces
108 client_test "MULTINIC root=nfs ip=eth1:dhcp ip=eth2:dhcp bootdev=eth1" \
109 00 01 02 \
110 "root=nfs:192.168.50.1:/nfs/client ip=eth1:dhcp ip=eth2:dhcp bootdev=eth1" \
111 "eth1 eth2" || return 1
112
113 # Require three interfaces with dhcp root-path
114 client_test "MULTINIC root=dhcp ip=eth0:dhcp ip=eth1:dhcp ip=eth2:dhcp bootdev=eth2" \
115 00 01 02 \
116 "root=dhcp ip=eth0:dhcp ip=eth1:dhcp ip=eth2:dhcp bootdev=eth2" \
117 "eth0 eth1 eth2" || return 1
8f4c0660
HH
118
119 kill_server
120 return 0
a71f1b49
PS
121}
122
123test_setup() {
124 # Make server root
0be1785a
HH
125 dd if=/dev/null of=$TESTDIR/server.ext2 bs=1M seek=60
126 mke2fs -F $TESTDIR/server.ext2
127 mkdir $TESTDIR/mnt
128 sudo mount -o loop $TESTDIR/server.ext2 $TESTDIR/mnt
a71f1b49
PS
129
130 kernel=$KVERSION
131 (
0be1785a 132 initdir=$TESTDIR/mnt
a71f1b49
PS
133 . $basedir/dracut-functions
134 dracut_install sh ls shutdown poweroff stty cat ps ln ip \
135 /lib/terminfo/l/linux dmesg mkdir cp ping exportfs \
136 modprobe rpc.nfsd rpc.mountd showmount tcpdump \
137 /etc/services sleep mount chmod
f3af7bd6
138 type -P portmap >/dev/null && dracut_install portmap
139 type -P rpcbind >/dev/null && dracut_install rpcbind
3b403b32 140 [ -f /etc/netconfig ] && dracut_install /etc/netconfig
f3af7bd6 141 type -P dhcpd >/dev/null && dracut_install dhcpd
a71f1b49
PS
142 [ -x /usr/sbin/dhcpd3 ] && inst /usr/sbin/dhcpd3 /usr/sbin/dhcpd
143 instmods nfsd sunrpc ipv6
144 inst ./server-init /sbin/init
145 inst ./hosts /etc/hosts
146 inst ./exports /etc/exports
147 inst ./dhcpd.conf /etc/dhcpd.conf
148 dracut_install /etc/nsswitch.conf /etc/rpc /etc/protocols
149 dracut_install rpc.idmapd /etc/idmapd.conf
f3af7bd6 150 if ldd $(type -P rpc.idmapd) |grep -q lib64; then
a71f1b49
PS
151 LIBDIR="/lib64"
152 else
153 LIBDIR="/lib"
154 fi
155
156 dracut_install $(ls {/usr,}$LIBDIR/libnfsidmap*.so* 2>/dev/null )
c5ef4b63 157 dracut_install $(ls {/usr,}$LIBDIR/libnfsidmap/*.so 2>/dev/null )
a71f1b49 158 dracut_install $(ls {/usr,}$LIBDIR/libnss*.so 2>/dev/null)
c5ef4b63
HH
159
160
161 nsslibs=$(sed -e '/^#/d' -e 's/^.*://' -e 's/\[NOTFOUND=return\]//' /etc/nsswitch.conf \
162 | tr -s '[:space:]' '\n' | sort -u | tr -s '[:space:]' '|')
163 nsslibs=${nsslibs#|}
164 nsslibs=${nsslibs%|}
165
166 dracut_install $(for i in $(ls {/usr,}$LIBDIR/libnss*.so 2>/dev/null); do echo $i;done | egrep "$nsslibs")
a71f1b49
PS
167 (
168 cd "$initdir";
169 mkdir -p dev sys proc etc var/run tmp var/lib/{dhcpd,rpcbind}
170 mkdir -p var/lib/nfs/{v4recovery,rpc_pipefs}
171 chmod 777 var/lib/rpcbind var/lib/nfs
172 )
173 inst /etc/nsswitch.conf /etc/nsswitch.conf
174 inst /etc/passwd /etc/passwd
175 inst /etc/group /etc/group
176 for i in /lib*/libnss_files**;do
177 inst_library $i
178 done
179
180 /sbin/depmod -a -b "$initdir" $kernel
8a080127
PS
181 cp -a /etc/ld.so.conf* $initdir/etc
182 sudo ldconfig -r "$initdir"
a71f1b49
PS
183 )
184
185 # Make client root inside server root
0be1785a 186 initdir=$TESTDIR/mnt/nfs/client
a71f1b49
PS
187 mkdir -p $initdir
188
189 (
190 . $basedir/dracut-functions
191 dracut_install sh shutdown poweroff stty cat ps ln ip \
192 /lib/terminfo/l/linux mount dmesg mkdir \
8a6ecb19 193 cp ping grep ls
a71f1b49
PS
194 inst ./client-init /sbin/init
195 (
196 cd "$initdir"
8a6ecb19 197 mkdir -p dev sys proc etc run
a71f1b49
PS
198 mkdir -p var/lib/nfs/rpc_pipefs
199 )
200 inst /etc/nsswitch.conf /etc/nsswitch.conf
201 inst /etc/passwd /etc/passwd
202 inst /etc/group /etc/group
203 for i in /lib*/libnss_files*;do
204 inst_library $i
205 done
206
8a080127
PS
207 cp -a /etc/ld.so.conf* $initdir/etc
208 sudo ldconfig -r "$initdir"
a71f1b49
PS
209 )
210
0be1785a
HH
211 sudo umount $TESTDIR/mnt
212 rm -fr $TESTDIR/mnt
a71f1b49
PS
213
214 # Make an overlay with needed tools for the test harness
215 (
0be1785a
HH
216 initdir=$TESTDIR/overlay
217 mkdir $TESTDIR/overlay
a71f1b49
PS
218 . $basedir/dracut-functions
219 dracut_install poweroff shutdown
0b53ca70 220 inst_hook emergency 000 ./hard-off.sh
778d2ba2 221 inst_simple ./99-idesymlinks.rules /etc/udev/rules.d/99-idesymlinks.rules
a71f1b49
PS
222 )
223
224 # Make server's dracut image
0be1785a 225 $basedir/dracut -l -i $TESTDIR/overlay / \
a71f1b49 226 -m "dash udev-rules base rootfs-block debug kernel-modules" \
778d2ba2 227 -d "piix ide-gd_mod ata_piix ext2 sd_mod e1000" \
0be1785a 228 -f $TESTDIR/initramfs.server $KVERSION || return 1
a71f1b49
PS
229
230 # Make client's dracut image
0be1785a 231 $basedir/dracut -l -i $TESTDIR/overlay / \
a71f1b49
PS
232 -o "plymouth" \
233 -a "debug" \
da4e6443 234 -d "piix sd_mod sr_mod ata_piix ide-gd_mod e1000 nfs sunrpc" \
0be1785a 235 -f $TESTDIR/initramfs.testing $KVERSION || return 1
a71f1b49
PS
236}
237
6c980807 238kill_server() {
0be1785a
HH
239 if [[ -s $TESTDIR/server.pid ]]; then
240 sudo kill -TERM $(cat $TESTDIR/server.pid)
241 rm -f $TESTDIR/server.pid
a71f1b49 242 fi
6c980807
HH
243}
244
245test_cleanup() {
0be1785a 246 kill_server
a71f1b49
PS
247}
248
249. $testdir/test-functions